VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
' Knoten in einem binren Baum.
'
' Diese Klasse modelliert einen Knoten in einem binren Baum mit Zeigern
' auf den rechten und linken Sohn und den Vater. Weiters enthlt 'Key' den
' Schlssel und 'Data' beliebige Daten, die an den Knoten gebunden sind.
'
Option Explicit

' Hier werden der Einfachheit halber Variablen anstatt von Eigenschaften
' verwendet (wird intern ja auch zu Eigenschaften umgesetzt).
Public Data As Variant
Public Key As Long

Private m_Father As CNode
Private m_LeftSon As CNode
Private m_RightSon As CNode

'***********************************
' User-defined Properties.
'***********************************

Public Property Get Father() As CNode
    Set Father = m_Father
End Property

Public Property Set Father(ByVal NewValue As CNode)
    Set m_Father = NewValue
End Property

Public Property Get LeftSon() As CNode
    Set LeftSon = m_LeftSon
End Property

Public Property Set LeftSon(ByVal NewValue As CNode)
    Set m_LeftSon = NewValue
End Property

Public Property Get RightSon() As CNode
    Set RightSon = m_RightSon
End Property

Public Property Set RightSon(ByVal NewValue As CNode)
    Set m_RightSon = NewValue
End Property
