VERSION 5.00
Begin VB.Form FMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "BinarySearchTree"
   ClientHeight    =   3270
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4665
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3270
   ScaleWidth      =   4665
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdTestTreeSort 
      Caption         =   "Test T&reeSort"
      Height          =   340
      Left            =   2445
      TabIndex        =   1
      Top             =   259
      Width           =   1575
   End
   Begin VB.TextBox txtOutput 
      BackColor       =   &H8000000F&
      Height          =   2270
      Left            =   262
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   2
      Top             =   749
      Width           =   4140
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "&Test BinSearchTree"
      Height          =   340
      Left            =   645
      TabIndex        =   0
      Top             =   252
      Width           =   1575
   End
End
Attribute VB_Name = "FMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents m_BinaryTree As CBinarySearchTree
Attribute m_BinaryTree.VB_VarHelpID = -1

Private Sub cmdTest_Click()
    Me.cmdTest.Enabled = False
    
    ReDim Data(0 To 10) As CNode
    Dim i As Long
    For i = 0 To UBound(Data)
        Set Data(i) = New CNode
    Next i
    Data(0).Key = 5
    Data(1).Key = 1
    Data(2).Key = 2
    Data(3).Key = 3
    Data(4).Key = 4
    Data(5).Key = 5
    Data(6).Key = 10
    Data(7).Key = 9
    Data(8).Key = 8
    Data(9).Key = 7
    Data(10).Key = 6
    
    '*******************************************
    Call m_BinaryTree.Insert(Data(0), Data(1))
    Call m_BinaryTree.Insert(Data(0), Data(2))
    Call m_BinaryTree.Insert(Data(0), Data(3))
    Call m_BinaryTree.Insert(Data(0), Data(4))
    Call AddText( _
        Me.txtOutput, _
        "Fge nacheinander in dieser Reihenfolge die Zahlen" & vbNewLine & _
        "      5, 1, 2, 3, 4" & vbNewLine & _
        "in einen leeren binren Baum ein." _
    )
    
    '*******************************************
    Call AddText( _
        Me.txtOutput, _
        vbNewLine & _
        vbNewLine & _
        "Ermittle grssten Schlssel im Baum:  " & CStr(m_BinaryTree.Maximum(Data(0)).Key) & "." _
    )
    
    '*******************************************
    Call m_BinaryTree.Insert(Data(0), Data(5))
    Call m_BinaryTree.Insert(Data(0), Data(6))
    Call m_BinaryTree.Insert(Data(0), Data(7))
    Call m_BinaryTree.Insert(Data(0), Data(8))
    Call m_BinaryTree.Insert(Data(0), Data(9))
    Call m_BinaryTree.Insert(Data(0), Data(10))
    Call AddText( _
        Me.txtOutput, _
        vbNewLine & _
        vbNewLine & _
        "Fge nacheinander in dieser Reihenfolge die Zahlen" & vbNewLine & _
        "      5, 10, 9, 8, 7, 6" & vbNewLine & _
        "in den binren Baum ein." _
    )
    
    '*******************************************
    Call AddText( _
        Me.txtOutput, vbNewLine & _
        vbNewLine & _
        "Ermittle kleinsten Schlssel im Baum:  " & CStr(m_BinaryTree.Minimum(Data(0)).Key) & "." _
    )
    
    '*******************************************
    Call AddText( _
        Me.txtOutput, _
        vbNewLine & _
        vbNewLine & _
        "Ermittle grssten Schlssel im Baum:  " & CStr(m_BinaryTree.Maximum(Data(0)).Key) & "." _
    )
    
    '*******************************************
    Call AddText( _
        Me.txtOutput, _
        vbNewLine & _
        vbNewLine & _
        "Nachfolger (Successor) von 7:  " & CStr(m_BinaryTree.Successor(Data(9)).Key) & "." _
    )
    
    '*******************************************
    Call AddText( _
        Me.txtOutput, vbNewLine & _
        vbNewLine & _
        "Vorgnger (Predecessor) von 7:  " & CStr(m_BinaryTree.Predecessor(Data(9)).Key) & "." _
    )
    
    '*******************************************
    Call m_BinaryTree.Delete(Data(0), Data(10))
    Call AddText( _
        Me.txtOutput, vbNewLine & _
        vbNewLine & _
        "Lschen von 6." _
    )
    
    '*******************************************
    Call AddText( _
        Me.txtOutput, _
        vbNewLine & _
        vbNewLine & _
        "Vorgnger (Predecessor) von 7:  " & CStr(m_BinaryTree.Predecessor(Data(9)).Key) & "." _
    )
End Sub

Private Sub AddText(ByVal TextBox As TextBox, ByVal Text As String)
    TextBox.SelStart = Len(TextBox.Text)
    TextBox.SelText = Text
End Sub

Private Sub cmdTestTreeSort_Click()
    Call TestTreeSort
End Sub

Private Sub Form_Load()
    Set m_BinaryTree = New CBinarySearchTree
End Sub

Private Sub m_BinaryTree_Traversed(ByVal Node As CNode, ByVal EventSource As EventType)
    Select Case EventSource
        Case eInOrder
            Debug.Print "'InOrder':  " & CStr(Node.Key)
        Case eEnumInterval
            Debug.Print "'EnumInterval':  " & CStr(Node.Key)
    End Select
End Sub
