Attribute VB_Name = "modTreeSort"
Option Explicit

Private m_BinaryTree As New CBinarySearchTree
Private m_Counter As Integer

Public Sub TestTreeSort()
    Dim Data(0 To 8) As CNode
    Dim i As Long
    For i = 0 To UBound(Data)
        Set Data(i) = New CNode
    Next i
    Data(0).Key = 10
    Data(1).Key = 30
    Data(2).Key = 2
    Data(3).Key = 32
    Data(4).Key = 64
    Data(5).Key = 12
    Data(6).Key = 30
    Data(7).Key = 18
    Data(8).Key = 4
    Dim s As String
    For i = 0 To UBound(Data)
        If i = 0 Then
            s = "Unsortierte Folge:" & _
                vbNewLine & _
                CStr(Data(i).Key)
        Else
            s = s & "  " & CStr(Data(i).Key)
        End If
    Next i
    Call TreeSort(Data)
    For i = 0 To UBound(Data)
        If i = 0 Then
            s = s & vbNewLine & _
                vbNewLine & _
                "Sortierte Folge:" & vbNewLine & _
                CStr(Data(i).Key)
        Else
            s = s & "  " & CStr(Data(i).Key)
        End If
    Next i
    Call MsgBox(s)
End Sub

'
' Sortiert eine Folge von "Knoten" 'Data(0 To n)'.
'
Public Sub TreeSort(ByRef Data() As CNode)
    Dim i As Long
    Dim r As CNode
    
    ' Alle Elemente in einen binren Baum einfgen.
    For i = 0 To UBound(Data)
        Call m_BinaryTree.Insert(r, Data(i))
    Next i
    
    ' Baum in Inorder-Reihenfolge durchgehen.
    Call InOrder(r, Data)
    
    ' Nach dem Sortieren zeigen die Referenzen 'Father', 'LeftSon' und
    ' 'RightSon' jedes Elements auf andere Elemente. In diesem Beispiel
    ' ersparen wir uns das Zurcksetzen.
End Sub

Private Sub InOrder(ByVal Root As CNode, ByRef Data() As CNode)
    Dim p As CNode
    Set p = Root
    If Not p Is Nothing Then
        Call InOrder(p.LeftSon, Data)
        
        ' Knoten in Quellarray an richtige Position zurckschreiben.
        Set Data(m_Counter) = p
        m_Counter = m_Counter + 1
        
        Call InOrder(p.RightSon, Data)
    End If
End Sub
